﻿<?php
/*******************************************************************************
Copyright (c) 2019 Clear Admin Software Kft.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met: 

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*******************************************************************************/


//Ez a script egy webaruhazat szimulal.
//Generalt rendeleseket lehet belole letolteni.
//Ha a Clear Admin Szamlazo programban beallitjuk,
//kepes nyomtataskor a szamla adatait vissza POST-olni a webaruhaz szoftverbe
//ugyanarra az URL-re, ami a rendelesletolteshez lett beallitva.
//A szamlazo program egy ugyanolyan formatumu XML-t kuld vissza
//a POST-ban, amilyet kapott, de szerepelnek benne a modositasok
//es a szamlaszam is (ORDERHEAD_INVOICE_NO_STR).
//Erre a visszakuldesre mutat peldat az alabbi if-ben a POST lekezelese.

	if($_SERVER['REQUEST_METHOD'] == 'POST'){
		echo 'Posted:<br>';
		echo htmlentities(file_get_contents("php://input"));

		$filename = dirname(__FILE__).DIRECTORY_SEPARATOR.'loggedpost.txt';
		$handle=fopen($filename, "a");
		if(!$handle) die("No rights to write $filename");
		fwrite($handle, file_get_contents("php://input"));
		return;
	}
	$last_timestamp = $_GET['last_orderhead_timestamp'];
	//error_log("a timestamp: $last_timestamp");
	//header('Content-Type', 'text/xml; charset=UTF-8');
	echo '<?xml version="2.0" encoding="UTF-8" standalone="yes" ?>';
	echo "\n<!DOCTYPE ORDERS>\n";
	echo "<ORDERS>\n";
	for($i=0; $i<3; $i++)
	{
		//sleep(1);
		ShowOrder($i);
	}
	echo "</ORDERS>\n";

	
	function getHeadCode()
	{
		$filename = dirname(__FILE__).DIRECTORY_SEPARATOR.'.order.txt';
		$code_ary = @file($filename);
		$code = $code_ary[0] + 1;
		$handle=fopen($filename, "w");
		if(!$handle) die("No rights to write $filename");
		fwrite($handle, $code);
		return $code + 0;
		
	}

	function ShowOrder($i)
	{
		$head_code = getHeadCode() + 0;
		$item_code = $head_code * 10;
		$timestamp = strftime('%Y-%m-%d %H:%M:%S');
		$today = date('Y-m-d');

?>
	<ORDER>
		<ORDERHEAD_CODE><?php echo $head_code?></ORDERHEAD_CODE>
		<ORDERHEAD_TIMESTAMP><?php echo $timestamp?></ORDERHEAD_TIMESTAMP>
		
		<ORDERHEAD_PARTNER_CODE><?php echo $i?></ORDERHEAD_PARTNER_CODE>
		<ORDERHEAD_PARTNER_NAME>Példa Vevő <?php echo $i?></ORDERHEAD_PARTNER_NAME>
		<ORDERHEAD_PARTNER_ZIP>1111</ORDERHEAD_PARTNER_ZIP>
		<ORDERHEAD_PARTNER_CITY>Budapest</ORDERHEAD_PARTNER_CITY>
		<ORDERHEAD_PARTNER_ADDRESS>Valami u. 33.</ORDERHEAD_PARTNER_ADDRESS>

		<ORDERHEAD_PARTNER_TAX_NO>12345678-1-42</ORDERHEAD_PARTNER_TAX_NO>
		<ORDERHEAD_PARTNER_EU_TAX_NO>HU12345678</ORDERHEAD_PARTNER_EU_TAX_NO>

		<ORDERHEAD_PARTNER_COUNTRY_INTERNATIONAL_CODE>SK</ORDERHEAD_PARTNER_COUNTRY_INTERNATIONAL_CODE>

		<ORDERHEAD_PARTNER_LANG_CODE>EN</ORDERHEAD_PARTNER_LANG_CODE>

		<ORDERHEAD_PARTNER_OTHER_DATA></ORDERHEAD_PARTNER_OTHER_DATA>
		
		<ORDERHEAD_PARTNER_MAIL_IS_SAME>0</ORDERHEAD_PARTNER_MAIL_IS_SAME>
		<ORDERHEAD_PARTNER_MAIL_NAME>Példa Vevő <?php echo $i?> levelezési címe</ORDERHEAD_PARTNER_MAIL_NAME>
		<ORDERHEAD_PARTNER_MAIL_ZIP>9999</ORDERHEAD_PARTNER_MAIL_ZIP>
		<ORDERHEAD_PARTNER_MAIL_CITY>Másikváros</ORDERHEAD_PARTNER_MAIL_CITY>
		<ORDERHEAD_PARTNER_MAIL_ADDRESS>Valami másik u. 2.</ORDERHEAD_PARTNER_MAIL_ADDRESS>

		<ORDERHEAD_PARTNER_CONTACT_NAME>Online Kázmér <?php echo $i?></ORDERHEAD_PARTNER_CONTACT_NAME>
		<ORDERHEAD_PARTNER_CONTACT_EMAIL>online.kazmer<?php echo $i?>@peldavevo<?php echo $i?>.hu</ORDERHEAD_PARTNER_CONTACT_EMAIL>

		<ORDERHEAD_PARTNER_MAIL_COUNTRY_INTERNATIONAL_CODE>SK</ORDERHEAD_PARTNER_MAIL_COUNTRY_INTERNATIONAL_CODE>
		
		<ORDERHEAD_PAYMENTMETHOD_CODE>Átutalás</ORDERHEAD_PAYMENTMETHOD_CODE>

		<ORDERHEAD_DATE_SHIPPED><?php echo $today?></ORDERHEAD_DATE_SHIPPED>
		<ORDERHEAD_DATE_PAYMENT_DUE><?php echo $today?></ORDERHEAD_DATE_PAYMENT_DUE>

		<ORDERHEAD_NO_VAT>1</ORDERHEAD_NO_VAT>
		<ORDERHEAD_NOVATREASON_CODE>FAD</ORDERHEAD_NOVATREASON_CODE>

		<ORDERHEAD_CURRENCY_ABBREVIATION>EUR</ORDERHEAD_CURRENCY_ABBREVIATION>

		<ORDERHEAD_SUBJECT>Online shopping / Internetes vásárlás</ORDERHEAD_SUBJECT>
		<ORDERHEAD_EXTRA_COMMENT>Ez egy extra megjegyzés a webáruházból a számlára. Rendelésszám: <?php echo $head_code?></ORDERHEAD_EXTRA_COMMENT>

		<ORDERHEAD_PAID>0</ORDERHEAD_PAID>

		<ORDERHEAD_VERIFIED>1</ORDERHEAD_VERIFIED>

		<ORDEREXTRA name="DATA1">Egyes extra adat</ORDEREXTRA>
		<ORDEREXTRA name="DATA2">Kettes extra adat</ORDEREXTRA>
		<ORDEREXTRA name="DATA3">Hármas extra adat</ORDEREXTRA>
		<ORDEREXTRA name="DATA4">Négyes extra adat</ORDEREXTRA>
		<ORDEREXTRA name="DATA5">Ötös extra adat</ORDEREXTRA>
		
		<ORDERITEM>
			<ORDERITEM_CODE><?php echo $item_code++?></ORDERITEM_CODE>
			
			<ORDERITEM_PRODUCT_CODE>1</ORDERITEM_PRODUCT_CODE>
			<ORDERITEM_STAT_NO>VTSZ 12345</ORDERITEM_STAT_NO>
			<ORDERITEM_PART_NO>abc123</ORDERITEM_PART_NO>
			<ORDERITEM_NAME>Példa termék 1</ORDERITEM_NAME>
			<ORDERITEM_NAME_TRANSLATION>Online Product 1</ORDERITEM_NAME_TRANSLATION>
			<ORDERITEM_COMMENT></ORDERITEM_COMMENT>
			<ORDERITEM_COMMENT_TRANSLATION></ORDERITEM_COMMENT_TRANSLATION>
			<ORDERITEM_UNIT>db</ORDERITEM_UNIT>
			<ORDERITEM_UNIT_TRANSLATION>pcs</ORDERITEM_UNIT_TRANSLATION>
			<ORDERITEM_VAT_CODE>1</ORDERITEM_VAT_CODE>
			<ORDERITEM_VAT_PERCENT>27</ORDERITEM_VAT_PERCENT>
			<ORDERITEM_VAT_NAME>27 %</ORDERITEM_VAT_NAME>
			
			<ORDERITEM_LIST_PRICE>333.333333</ORDERITEM_LIST_PRICE>
			<ORDERITEM_PRICE>333.333333</ORDERITEM_PRICE>
			<ORDERITEM_QTY>1</ORDERITEM_QTY>

			<ORDERITEM_DISCOUNT_TYPE>0</ORDERITEM_DISCOUNT_TYPE>
			<ORDERITEM_DISCOUNT_PERCENT></ORDERITEM_DISCOUNT_PERCENT>
		</ORDERITEM>
		<ORDERITEM>
			<ORDERITEM_CODE><?php echo $item_code++?></ORDERITEM_CODE>
			
			<ORDERITEM_PRODUCT_CODE>2</ORDERITEM_PRODUCT_CODE>
			<ORDERITEM_STAT_NO>VTSZ 12345</ORDERITEM_STAT_NO>
			<ORDERITEM_NAME>Példa termék 2</ORDERITEM_NAME>
			<ORDERITEM_NAME_TRANSLATION>Online Product 2</ORDERITEM_NAME_TRANSLATION>
			<ORDERITEM_COMMENT></ORDERITEM_COMMENT>
			<ORDERITEM_COMMENT_TRANSLATION></ORDERITEM_COMMENT_TRANSLATION>
			<ORDERITEM_UNIT>db</ORDERITEM_UNIT>
			<ORDERITEM_UNIT_TRANSLATION>pcs</ORDERITEM_UNIT_TRANSLATION>
			<ORDERITEM_VAT_CODE>1</ORDERITEM_VAT_CODE>
			<ORDERITEM_VAT_PERCENT>27</ORDERITEM_VAT_PERCENT>
			<ORDERITEM_VAT_NAME>27 %</ORDERITEM_VAT_NAME>
			
			<ORDERITEM_LIST_PRICE>100</ORDERITEM_LIST_PRICE>
			<ORDERITEM_QTY>1</ORDERITEM_QTY>

			<ORDERITEM_DISCOUNT_TYPE>1</ORDERITEM_DISCOUNT_TYPE>
			<ORDERITEM_DISCOUNT_PERCENT>10</ORDERITEM_DISCOUNT_PERCENT>
		</ORDERITEM>
		<ORDERITEM>
			<ORDERITEM_CODE><?php echo $item_code++?></ORDERITEM_CODE>
			
			<ORDERITEM_PRODUCT_CODE>3</ORDERITEM_PRODUCT_CODE>
			<ORDERITEM_STAT_NO>VTSZ 12345</ORDERITEM_STAT_NO>
			<ORDERITEM_NAME>Példa termék 3</ORDERITEM_NAME>
			<ORDERITEM_NAME_TRANSLATION>Online Product 3</ORDERITEM_NAME_TRANSLATION>
			<ORDERITEM_COMMENT></ORDERITEM_COMMENT>
			<ORDERITEM_COMMENT_TRANSLATION></ORDERITEM_COMMENT_TRANSLATION>
			<ORDERITEM_UNIT>db</ORDERITEM_UNIT>
			<ORDERITEM_UNIT_TRANSLATION>pcs</ORDERITEM_UNIT_TRANSLATION>
			<ORDERITEM_VAT_CODE>1</ORDERITEM_VAT_CODE>
			<ORDERITEM_VAT_PERCENT>27</ORDERITEM_VAT_PERCENT>
			<ORDERITEM_VAT_NAME>27 %</ORDERITEM_VAT_NAME>
			
			<ORDERITEM_LIST_PRICE>220</ORDERITEM_LIST_PRICE>
			<ORDERITEM_PRICE>200</ORDERITEM_PRICE>
			<ORDERITEM_QTY>1</ORDERITEM_QTY>

			<ORDERITEM_DISCOUNT_TYPE>2</ORDERITEM_DISCOUNT_TYPE>
			<ORDERITEM_DISCOUNT_PERCENT></ORDERITEM_DISCOUNT_PERCENT>
		</ORDERITEM>
	</ORDER>
<?php
	}
?>
